// noinspection JSJQueryEfficiency

/**
 * @file
 * Js for Glossary Content .
 */

(function ($, Drupal) {
    'use strict';
    Drupal.behaviors.GlossaryContent = {
        attach: function (context) {
            if (context === document) {
              $('body').append('<div id="glossary-dialog" class="hidden" title="Term definition"><div id="glossary-dialog-inner"><div class="ajax-progress ajax-progress-throbber"><div class="ajax-throbber">' + Drupal.t('Loading...') + '</div></div></div></div>');
            }

            $('.glos-term').once('glossaryListenner').on('click', function (event) {
                event.preventDefault();
                var termId = $(this).data('gterm');
                var termText = $(this).text();
                $('#glossary-dialog').dialog({
                    autoOpen: true,
                    resizable: false,
                    modal: true,
                    close: function () {
                        $('#glossary-dialog-inner').html('<div class="ajax-progress ajax-progress-throbber"><div class="ajax-throbber">' + Drupal.t('Loading...') + '</div></div>');
                    },
                    buttons: {
                        Close: function () {
                            $(this).dialog('close');
                            // $(this).dialog('destroy').remove();
                            $('#glossary-dialog-inner').html('<div class="ajax-progress ajax-progress-throbber"><div class="ajax-throbber">' + Drupal.t('Loading...') + '</div></div>');
                        }
                    }
                });
                // Call Ajax here.
                var url = Drupal.url('glossary-get-term-by-id/' + termId);
                $.ajax({
                    url:url,
                    dataType: "json",
                    type: "GET",
                    success: function (data) {
                        var dialogInner = $('#glossary-dialog-inner');
                        dialogInner.html('');
                        if (data.name && data.description) {
                            dialogInner.append('<b>' + data.name + '</b><br/>');
                            dialogInner.append(data.description);

                            dialogInner.removeClass('hidden');
                            var event = new CustomEvent('glossary_modal_show', { detail: data });
                            document.dispatchEvent(event);

                           /*
                            HOOK for Modal if using "hook_term_glossary_alter_result"
                            use to append custom data to the modal.
                            document.addEventListener('glossary_modal_show', function (e) {
                                console.log(e);
                                //alert(detail.name);
                                $('#glossary-dialog-inner').once().append('<h2>test</h2>');
                            }, false);

                            */

                        }
                        else {
                          dialogInner.html('No results found for' + termText);
                        }
                    }
                });

            });

        }
    };
})(jQuery, Drupal);
